<?php
/*************************************************************

 File: acl.php3
 Author: gernot
 Revision: 1.0.0
 Date: 1999/05/30

 This script showes and changes the Access LIST of a Mailbox

 Copyright 1999 Gernot Stocker <muecketb@sbox.tu-graz.ac.at>

 You should have received a copy of the GNU Public
 License along with this package; if not, write to the
 Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA 02111-1307, USA.
 
 THIS PROGRAM IS AS IT IS! THE AUTHOR TAKES NO RESPONSABILTY ABOUT 
 EVENTUAL DEMAGES, SECURITS-HOLES OR ATTACKES, WHICH COULD BE ENABLED 
 BY THIS PROGRAM
 
 ***************************************************************/
 

/*
  To Show and Change Access LIST parameters
      needed variables:

	 $username =   Name of the owner of der mailbox
	 $folder   =   Mailboxfolder

*/
  if(!isset($PHP_AUTH_USER)) 
      {
             Header("WWW-Authenticate: Basic realm=\"MailAdmins\"");
                     Header("HTTP/1.0 401 Unauthorized");
		     echo "You need a valid user and password to access this page!";
		     exit; 

      }
/*
  Initialising variables and arrays
*/
  require("lib/cyradm-php.lib");
  define("INCPATH", "includes");
  $folderorig=$folder;

  $folder= str_replace("/", ".",$folder);

  $test=array( "lookup"     => "l",
               "read"       => "r",
	       "seen"       => "s",
	       "write"      => "w",
	       "insert"     => "i",
	       "post"       => "p",
	       "create"     => "c",
	       "delete"     => "d",
	       "administer" => "a");


/*
   Get ACL of the specified folder from Server
*/
  $cconn = new cyradm;
  $cconn->imap_login();
  $acl = $cconn->getacl("$folder");
  $cconn->imap_logout();


/*
   Compose the List of already set user ACL's
*/
   include(INCPATH."/acl_0_header.inc");
   if (count($acl)>0)
   { 
    while (list($key, $val) = each($acl)) 
       {                                                                                 
        print "<tr><td> $key </td>\n";
        print "<form action=\"action.php3\" method=post>\n";
        while (list($right, $set) = each($test)) 
            {                                                                                 
              print "<td>$right <input type=checkbox name=\"$right\"";            
              $pos=strstr($val,$set);
              if (strstr($val,$set)) { print "checked"; };
	      print " value=\"$set\"></td>\n";
 	    }
	$test=$test;
        include(INCPATH."/acl_1_userchange.inc");
       }
   }


/*
   Compose the form "Adding User to ACL List with specified ACR"
*/

   include(INCPATH."/acl_2_adduser_begin.inc");
   while (list($right, $set) = each($test)) 
     {                                                                                 
       print "<td> $right <input type=checkbox name=\"$right\" value=\"$set\"> </td>\n";
     }
   include(INCPATH."/acl_3_adduser_end.inc");


/*
   Compose the form "Deleting a User from the ACL of the folder"
*/
   $acl=$acl;		 
   while (list($key, $val) = each($acl)) 
     {                                                                                 
       print "<option value=$key>$key</option>\n ";
     }
   include(INCPATH."/acl_4_rmuser.inc");
   include(INCPATH."/footer.inc");
?>
